{% extends "app/marketplaces.html" %}

{% block active_balancing_sessions %}

{% load staticfiles %}
<link rel="stylesheet" href="{% static 'app/content/font-awesome.min.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'app/content/bootstrap-table.min.css' %}" />
<script src="{% static 'app/scripts/bootstrap-table.js' %}"></script>
<link rel="stylesheet" type="text/css" href="{% static 'app/content/bootstrap-datetimepicker.css' %}" />
<script src="{% static 'app/scripts/moment.min.js' %}"></script>
<script src="{% static 'app/scripts/bootstrap-datetimepicker.js' %}"></script>

{% csrf_token %}

<script type="text/javascript">
    $(".vertical_tab").removeClass("active");
    $("#balancing_tab").addClass("active");
    $(".tab-pane").removeClass("active");
    $("#balancing").addClass("active");
    var MPLACE_URL = "{{ MPLACE_URL }}";
</script>

{% if actor == None %}
<h3>You have not been mapped to a known Market Actor. Please contact the Marketplace administrator.</h3>
{% else %}
{% if not session %}
  <h3>Sorry, no active sessions were found.</h3>
{% else %}

<script type="text/javascript">
    function setActionStatusFormatter(value, row, index) {
        return ActionStatus.formatter(value);
    }

    function resolve_type (id) {
      switch(id) {
          case 1:
              return "<div style=\"color:red;\">Bid</div>";
              break;
          case 2:
              return "<div style=\"color:green;\">Offer</div>";
              break;
          default:
              return "";
      }
    }

    function modal_actuate(url, method, id){
        var $inputs = $('#AddActionForm input');
        var values = {};
        $inputs.each(function () {
            if (this.id === "type") {
                values["actionTypeid"] = $(this).val();
            } else {
                values[this.id] = $(this).val();
            }

            $(this).val('');
            $('#uom').val($('#uoml').val());
            $('#type').val($('#typel').val());
        });

        values['date'] = moment().format();
        values['actionStartTime'] = moment(values['actionStartTime'], 'YYYY-MM-DD HH:mm').format();
        values['actionEndTime'] = moment(values['actionEndTime'], 'YYYY-MM-DD HH:mm').format();
        values['marketSessionid'] = {{session.id}};
        values['marketActorid'] = {{actor.id}};
        values['formid'] = getSessionForm(MPLACE_URL+ $("#select_balancing_mplace").val() +"/marketsessions/" + $("#select_balancing_session").val() + "/", $("#select_balancing_mplace").val(), $("#select_balancing_session").val());
        values['actionStatusid'] = {"id":1, "status":"Unchecked"} ;
        if (id != null) {
          values['id'] = id;
        }
        $('#actionStartTime').data("DateTimePicker").minDate(moment());
        $('#actionStartTime').data("DateTimePicker").maxDate(moment().add(32, 'hours'));
        $('#actionEndTime').data("DateTimePicker").minDate(moment().add(1, 'hours'));
        $('#actionEndTime').data("DateTimePicker").maxDate(moment().add(33, 'hours'));
        $('#addAction').modal('hide');
        $.ajax({
          url:url,
          type: method,
          dataType:"json",
          contentType: "application/json; charset=utf-8",
          data:JSON.stringify(values),
          success: function(){
            $("#data_table_session_{{session.id}}").bootstrapTable('refresh', {silent: true});
          },
          error: function(){
            $("#data_table_session_{{session.id}}").bootstrapTable('refresh', {silent: true});
          }
        });
    }

    function newAction() {
      $("#actionStartTime").val('');
      $("#actionEndTime").val('');
      $("#price").val('');
      $("#deliveryPoint").val('');
      $("#value").val('');
      $("#typel").val('').change();
      $("#uoml").val('').change();
      $("#modalAccept").html("Add");
      $("#modalAccept").unbind();
      $("#modalAccept").click(function(){
          modal_actuate("{{ib_url}}{{session.marketplaceid.id}}/marketsessions/{{session.id}}/actions", "POST");
      });
      $("#addAction").modal('show');
    }

    function editAction(id){
      $.get( "{{ib_url}}{{session.marketplaceid.id}}/marketsessions/{{session.id}}/actions/" + id, function( data ) {
          $("#actionStartTime").val(moment(data.actionStartTime).format('YYYY-MM-DD HH:mm'));
          $("#actionEndTime").val(moment(data.actionEndTime).format('YYYY-MM-DD HH:mm'));
          $("#price").val(data.price);
          $("#deliveryPoint").val(data.deliveryPoint);
          $("#value").val(data.value);
          if (data.actionTypeid.type == "offer") {
            $("#typel").val('offer').change();
          } else {
            $("#typel").val('bid').change();
          }
          if (data.uom.toUpperCase() == "KWh") {
            $("#uoml").val('KWh').change();
          } else {
            $("#uoml").val('MWh').change();
          }
          $("#modalAccept").html("Update");
          $("#modalAccept").unbind();
          $("#modalAccept").click(function(){
            modal_actuate("{{ib_url}}{{session.marketplaceid.id}}/marketsessions/{{session.id}}/actions/" + data.id + "/edit", "PUT", data.id);
          });
          $("#addAction").modal('show');
      });
    }

    function removeAction(id) {
      $.get( "{{ib_url}}{{session.marketplaceid.id}}/marketsessions/{{session.id}}/actions/" + id, function( data ) {
        data.actionStatusid = getActionStatus(ACTION_STATUS_URL, "withdrawn");
        $.ajax({
            type: "PUT",
            url: "{{ib_url}}{{session.marketplaceid.id}}/marketsessions/{{session.id}}/actions/" + id,
            contentType: "application/json",
            data: JSON.stringify(data),
          success: function(){
            $("#data_table_session_{{session.id}}").bootstrapTable('refresh', {silent: true});
          },
          error: function(){
            $("#data_table_session_{{session.id}}").bootstrapTable('refresh', {silent: true});
          }
        });
      });
    }

    function responseHandler(json) {
      var timeFormatStr = "YYYY-MM-DD HH:mm";
      var ret = [];
        $.each(json, function(i, element) {
            var obj = {};
            obj['id'] = element.pk;
            obj['date'] = moment(element.fields.date).format(timeFormatStr);
            obj['actionStartTime'] = moment(element.fields.actionStartTime).format(timeFormatStr);
            obj['actionEndTime'] = moment(element.fields.actionEndTime).format(timeFormatStr);
            obj['value'] = Number(element.fields.value).toFixed(3) + " " + element.fields.uom;
            obj['price'] = Number(element.fields.price).toFixed(2);
            obj['actionType'] = resolve_type(element.fields.actionType);
            obj['actionStatus'] = setActionStatusFormatter(element.fields.actionStatus);
            obj['edit'] = [
            '<a class="edit" data-att href="javascript:void(0)" title="Edit" onclick="editAction('+element.pk+');">',
            '<i class="glyphicon glyphicon-edit"></i>',
            '</a>  ',
            '<a class="remove" href="javascript:void(0)" title="Remove" onclick="removeAction('+element.pk+');">',
            '<i class="glyphicon glyphicon-trash" style="color:red;"></i>',
            '</a>'
        ].join('');
            ret.push(obj);
        });
        return ret;
    }
</script>

<center>
    <div>Session is active from {{ session.sessionStartTime | date:'D, d M Y, H:i:s e'}} until <b>{{ session.sessionEndTime | date:'D, d M Y, H:i:s e'}}</b></div>
    <div>Delivery is valid from {{ session.deliveryStartTime | date:'D, d M Y, H:i:s e'}} until {{ session.deliveryEndTime | date:'D, d M Y, H:i:s e'}}.</div>
{% if lastClearingPrice %}
    <div>Last clearing price was {{lastClearingPrice|floatformat:2}}&#8364;/MWh.</div>
{% endif %}

</center>

<div id="toolbar_{{session.sessionStatusid.status}}_{{session.id}}" class="btn-group"> <button id="newbtn{{session.id}}" class="btn btn-default" onclick="newAction();"> <i class="glyphicon glyphicon-plus"></i> </button> <button id="slctbtn_{{session.id}}" type="button" class="btn btn-default" disabled> <i class="glyphicon glyphicon-ok"></i> </button></div>
<table
    id="data_table_session_{{session.id}}"
    data-toolbar="#toolbar_{{session.sessionStatusid.status}}_{{session.id}}"
    data-toggle="table"
    class="table"
    data-side-pagination="client"
    data-pagination="true"
    data-search="true"
    data-id-field="id"
    data-page-list="[10, 25, 50, 100, ALL]"
    data-sort-name="active"
    data-sort-order="desc"
    data-click-to-select="true"
    data-single-select="true"
    data-page-list="[5, 10, 20, 50, 100, 200]"
    data-url="{% url 'data_tables_actor' session.marketplaceid.marketServiceTypeid.timeFrameid.type session.marketplaceid.marketServiceTypeid.type %}"
    data-response-handler="responseHandler"
    >
    <thead>
        <tr>
            <!-- <th data-field="state" data-checkbox="true"></th> -->
            <th class="th th-inner" data-sortable="true" data-field="id">ID</th>
            <th class="th th-inner" data-sortable="true" data-field="date">Date</th>
            <th class="th th-inner" data-sortable="true" data-field="actionStartTime">Start Time</th>
            <th class="th th-inner" data-sortable="true" data-field="actionEndTime">End Time</th>
            <th class="th th-inner" data-sortable="true" data-field="value">Value</th>
            <th class="th th-inner" data-sortable="true" data-field="price">Price (&#8364;/MWh)</th>
            <th class="th th-inner" data-sortable="true" data-field="actionType" >Type</th>
            <th class="th th-inner" data-sortable="true" data-field="actionStatus">Status</th>
            <th class="th th-inner" data-sortable="false" data-field="edit">Manage</th>
        </tr>
    </thead>
    <tbody>
    </tbody>
</table>

<!--Add Action modal-->
<div class="modal fade" id="addAction" tabindex="-1" role="dialog" aria-labelledby="addActionLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="addActionLabel">Place a new market action</h4>
            </div>
            <form class="form-horizontal marginstopbot" id="AddActionForm" onsubmit="return false">
                <div class="form-group">
                    <label for="actionStartTime" class="col-sm-4 control-label">Action start time</label>
                    <div class='col-sm-6 date'>
                        <input type='text' class="form-control" placeholder="Action start time" id='actionStartTime' />
                    </div>
                </div>
                <div class="form-group">
                    <label for="actionEndTime" class="col-sm-4 control-label">Action end time</label>
                    <div class="col-sm-6 date">
                        <input type='text' class="form-control" placeholder="Action end time" id='actionEndTime' />
                    </div>
                </div>
                <div class="form-group">
                    <label for="value" class="col-sm-4 control-label">Value</label>
                    <div class="col-sm-6">
                        <input type="number" class="form-control" id="value" placeholder="Value"/>
                    </div>
                </div>
                <div class="form-group">
                    <label for="uom" class="col-sm-4 control-label">Unit of measurement</label>
                    <div class="col-sm-6">
                        <select class="form-control" id="uoml">
                            {%comment%}<option value="KWh">KWh</option>{%endcomment%}
                            <option value="MWh">MWh</option>
                        </select>
                        <input type="hidden" id="uom" value="KWh"/>
                    </div>
                </div>
                <div class="form-group">
                    <label for="price" class="col-sm-4 control-label">Price (&#8364;/MWh)</label>
                    <div class="col-sm-6">
                        <input type="number" class="form-control" id="price" placeholder="Price"/>
                    </div>
                </div>
                <div class="form-group">
                    <label for="deliveryPoint" class="col-sm-4 control-label">Delivery point</label>
                    <div class="col-sm-6">
                        <input class="form-control" id="deliveryPoint" placeholder="Delivery point"/>
                    </div>
                </div>
                <div class="form-group">
                    <label for="type" class="col-sm-4 control-label">Type</label>
                    <div class="col-sm-6">
                        <select class="form-control" id="typel">
                            <option value="offer">Sell</option>
                            <option value="bid">Buy</option>
                        </select>
                        <input type="hidden" id="type" value="offer"/>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-12 centre">
                        <button id="modalAccept" class="btn btn-accept">Add</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>


<script>
$( document ).ready(function() {
        $("#data_table_session_{{session.id}}").bootstrapTable({silent: true});
        $("#data_table_session_{{session.id}}").bootstrapTable('refresh');
        setInterval(function(){ $("#data_table_session_{{session.id}}").bootstrapTable('refresh', {silent: true}); }, 5000);

        $('#actionStartTime').datetimepicker();
        $('#actionStartTime').data("DateTimePicker").format('YYYY-MM-DD HH:mm');
        $('#actionStartTime').data("DateTimePicker").maxDate(moment().add(32, 'hours'));
        $('#actionEndTime').datetimepicker();
        $('#actionEndTime').data("DateTimePicker").format('YYYY-MM-DD HH:mm');
        $('#actionEndTime').data("DateTimePicker").minDate(moment().add(1, 'hours'));
        $('#actionEndTime').data("DateTimePicker").maxDate(moment().add(33, 'hours'));
        $("#actionEndTime").on("dp.show", function (e) {
            $('#actionEndTime').data("DateTimePicker").date(moment($('#actionStartTime').data("DateTimePicker").date()).add(1, 'hours'));
        });
    });
</script>

{% endif %}

{% endif %}
{% endblock %}
